# ipydeck

`ipydeck` is yet another Jupyter widget for [deck.gl](https://deck.gl/), built on [anywidget](https://github.com/manzt/anywidget/).

## Installation

```sh
pip install ipydeck
```

## Usage

From <https://deck.gl/playground>:

```py
from ipydeck import Deck, Layer, ViewState

layers = [
    Layer(
        type="GeoJsonLayer",
        data="https://raw.githubusercontent.com/visgl/deck.gl-data/master/examples/geojson/vancouver-blocks.json",
        opacity=0.8,
        stroked=False,
        filled=True,
        extruded=True,
        wireframe=True,
        elevation_scale=0.1,
        get_elevation="@@=properties.valuePerSqm",
        get_fill_color=[199, 233, 180],
        get_line_color=[255, 255, 255],
    )
]

view_state = ViewState(
    latitude=49.254, longitude=-123.13, zoom=11, max_zoom=16, pitch=45, bearing=0
)

deck = Deck(
    layers=layers,
    initial_view_state=view_state,
    map_style="light",
)

deck
``````

![screenshot](assets/screenshot.png)

## Alternatives

- [pydeck](https://deckgl.readthedocs.io/)
- [lonboard](https://github.com/developmentseed/lonboard/)

## License

MIT
